Subject: Re: [PATCH net-next] nfp: add L4 RSS hashing on UDP traffic

From: Jakub Kicinski <[email-masked]>
Date: Wed, 24 May 2023 09:28:39 -0700

On Wed, 24 May 2023 18:14:55 +0200 Paolo Abeni wrote:
> > Ugh, that's what I thought. I swear I searched it for "fragment"
> > yesterday and the search came up empty. I blame google docs :|
> > 
> > We should probably still document the recommendation that if the NIC
> > does not comply and hashes on ports with MF set - it should disable 
> > UDP hashing by default (in kernel docs).  
> 
> FTR, the above schema could still move the same flow on different
> queues - if some datagrams in the given flow are fragmented and some
> are not.

Ah, you're right.

> Out of sheer ignorance I really don't know if/how many NICs implement
> RSS hashing with the above schema (using different data according to
> the IP header fragments related fields). I'm guessing some (most?) use
> a simpler schema (always L4 if available or never L4).
> 
> I *think* we could as well suggest always using L4 for UDP. If users
> care about fragments they will have to explicitly deal with them
> anyway.

Makes sense. QUIC changed the math on how likely UDP fragmentation is.